package com.fp.persistence.pgeneral.receive;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TRECEIVABLETEMPLATEDESC*/
@Entity(name="TreceivableTemplateDesc")
@Table(name="TRECEIVABLETEMPLATEDESC")
public class TreceivableTemplateDesc extends com.fp.dto.AbstractDataBalanceTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TreceivableTemplateDesc
*/
@EmbeddedId
private TreceivableTemplateDescKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistick loking del registro
*/
private Integer recordversion;

@Column(name="DESCRIPCTION", nullable=true)

/**
* Descripcion del codigo de plantilla de cuenta por cobrar.
*/
private String descripction;

/**Contructor por defecto*/
public TreceivableTemplateDesc(){
}
/**Contructor de TreceivableTemplateDesc
@param pPk Clave Primaria del entity
*/
public TreceivableTemplateDesc(TreceivableTemplateDescKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TreceivableTemplateDesc
*/
public static TreceivableTemplateDesc find(EntityManager pEntityManager,TreceivableTemplateDescKey pKey) throws Exception{
    TreceivableTemplateDesc obj = pEntityManager.find(TreceivableTemplateDesc.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TreceivableTemplateDesc
@return El objeto que referencia a la Clave primaria de TreceivableTemplateDesc
*/
public TreceivableTemplateDescKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TreceivableTemplateDesc
@param pPk El objeto que referencia a la nueva Clave primaria de TreceivableTemplateDesc
*/
public void setPk(TreceivableTemplateDescKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de descripction
@return valor de descripction*/
public String getDescripction(){
  return descripction;
}
/**Fija el valor de descripction
@param pDescripction nuevo Valor de descripction*/
public void setDescripction(String pDescripction){
  descripction=pDescripction;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TreceivableTemplateDesc))return false;
    TreceivableTemplateDesc that = (TreceivableTemplateDesc) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TreceivableTemplateDesc
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TreceivableTemplateDesc
*/
public Object createInstance(){
 TreceivableTemplateDesc instance=new TreceivableTemplateDesc();	
 instance.setPk(new TreceivableTemplateDescKey());
 return instance;
}
/**Clona la entidad TreceivableTemplateDesc
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TreceivableTemplateDesc p=(TreceivableTemplateDesc)this.clone();
  p.setPk((TreceivableTemplateDescKey)this.pk.cloneMe());
  return p;
}
}
